#!/usr/bin/perl 
#This file is part of vigilant configuration maker.

#vigilant configuration maker is free software: 
#you can redistribute it and/or modify it under the terms 
#of the GNU General Public License as published by the
#Free Software Foundation, either version 3 of the License, or
#(at your option) any later version.

# vigilant configuration maker is distributed in the hope that 
# it will be useful,but WITHOUT ANY WARRANTY; without even the
# implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
# See the GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with vigilant configuration maker.  If not, see
# <http://www.gnu.org/licenses/>.  

# version 2.3
# 08/18/2018
# * enabled ident and addhost commands by default

# version 2.2
# 09/08/2017
# add support for what vhost to set, vhost4 or vhost6
# Also, added support for listening on a specific host or ip

# version 2.1
# Update config to suit the eggdrop v1.8.1 - the latest version
# 06/10/2017
# New changes
# 	* ssl
# 	* ipv6
# 	* new vhost settings for my ip and my host previously
#	* new server settings
#	* Made the comments worded better, and how they look
#	* Changed errors wording a bit.

# vigilant's configuration maker v2.0
# January 7, 2012
# * Checked if the settings are valid for eggdrop1.6.21 - Checkmark!
# * Just looking for a few simple suggestions to improve this.
# * I will change it soon.
# * Also, added the new config options, completely.
# * Should be good to go, for the time being! 

# Version 1.1
# October 23rd, 2007


# Read the README file for instructions and information.

# things to do
# * add scripts/ option to load scripts
#* some other stuff

$ver = "2.3";
$curtime = localtime();

# Say on the screen greeting, and ask questions
system ("clear");
system ("cat vigbanner");
print "configuration maker v$ver\n\n";
print("Started at $curtime\n");
print "Configuration begins...\n\n";
print "BOTS NICKNAME\n";
chomp($bot_conf = <STDIN>);
# If else statement for bot_conf variable
if (length($bot_conf) < 1) {
	print "Cannot leave bot's nickname empty, try again.\n";
chomp($bot_conf = <STDIN>);
} 
while (length($bot_conf) < 1) { 
	print "Please try again\n"; 
chomp($bot_conf = <STDIN>);
} 
		print "Continuing...\n\n";
		
# Fakenick
print "FAKE BOT NICK\nUsed for the botnet nick and the configuration file name\n";
chomp($fakenick_conf = <STDIN>);
while(length($fakenick_conf) < 1) {
	print "Please enter a fake bot nick\n";
chomp($fakenick_conf = <STDIN>);
}
	print "Continuing...\n\n";

# Save owner email
print "YOUR E-MAIL ADDRESS\n";
chomp($email_conf = <STDIN>);
if (length($email_conf) < 5) {
	print "Too short of an e-mail address...\n";
chomp($email_conf = <STDIN>);
}
while (length($email_conf) < 5) {
	print "Try again.. too short.\n";
chomp($email_conf = <STDIN>);
} 
		print "Continuing...\n\n";  

# Save the owners nickname and grab , chomp, save and say done
print "YOUR NICKNAME\n";
chomp($ownernick_conf = <STDIN>);
if (length($ownernick_conf) lt 1) {
print "Please enter your nickname on IRC..\n";
chomp($ownernick_conf = <STDIN>);
}
while (length($ownernick_conf) lt 1) {
	print "Keep trying..\n";
chomp($ownernick_conf = <STDIN>);
}
		print "Continuing...\n\n"; 
	
	

# Network name and all
print "IRC NETWORK\n";
chomp($network_conf = <STDIN>);
if (length($network_conf) lt 1) { 
	print qq{Cannot leave the IRC Network field empty.. \n};
chomp($network_conf = <STDIN>);
}
while(length($network_conf) lt 1) {
	print "Try again!\n";
chomp($network_conf = <STDIN>);
} 
	print "Continuing...\n\n";


#  Channel to join after connecting
print "CHANNEL TO JOIN - INCLUDE #\n";
chomp($chantojoin_conf = <STDIN>);
while (length($chantojoin_conf) < 2) {
	print "Please enter a channel to join\n";
chomp($chantojoin_conf = <STDIN>);
} 
	print "Continuing...\n\n";


# Owners nick
print "OWNERS NICKNAME\n";
chomp($owners_conf = <STDIN>);
while (length($owners_conf) < 1) {
print "Please enter the owner's nickname..\n";
chomp($owners_conf = <STDIN>);
} 
	print "Continuing...\n\n";

# Away message to set
print "BOTS AWAY MESSAGE. Type no for no away message.\n";
chomp($awaymsg_conf = <STDIN>);
while(length($awaymsg_conf) < 1) {
	print "Please enter an away message..\n";
chomp($awaymsg_conf = <STDIN>);
} 
if($awaymsg_conf =~ /^no/) {
$awaystring = qq{#putquick "away :$awaymsg_conf"};
} else {
$awaystring = qq{putquick "away :$awaymsg_conf"};
} 
	print "Continuing...\n\n";
	


# Vhost4 or vhost6
print "Enter vhost4 for a normal host or ip, or vhost6 for a ipv6 ip or host. Enter disable to disable setting a vhost4 or vhost6 value\n";
chomp($foursixinput = <STDIN>);
while(length($foursixinput) < 6) {
	print("Please enter vhost4 or vhost6, or disable\n");
chomp($foursixinput = <STDIN>);
}
if ($foursixinput eq 'vhost4') {
	print("Enter the ip or host please..\n");
chomp($ip_ornot = <STDIN>);
$ip_ornot = qq{set vhost4 "$ip_ornot"};
} elsif ($foursixinput eq 'vhost6') {
	print("Enter the vhost6 ip or host please..\n");
chomp($ip_ornot = <STDIN>);
$ip_ornot = qq{set vhost6 "$ip_ornot"};
} elsif($foursixinput =~ /^disable/) {
$ip_ornot = qq{#set vhost4 "none"};
} else {
$ip_ornot = qq{set vhost4 "$ip_ornot"};
}
	print("Continuing...\n\n");

# listen-addr
print "Enter the listen-addr, so an ip or a host that will be used for listening on, this is important.\n";
chomp($listen_addr = <STDIN>);
while (length($listen_addr) < 7) {
	print("Please enter the ip or host that will be used for binding to and listening on.\n");
chomp($listen_addr = <STDIN>);
$listen_addr = qq{set listen-addr "$listen-addr"};
}

	print("Continuing...\n\n");

# Bot's realname field
print "REAL NAME OF BOT\n";
chomp($realname_conf = <STDIN>);
while(length($realname_conf) < 1) {
	print("Please enter a real name for the bot..\n");
chomp($realname_conf = <STDIN>);
} 
	print "Continuing...\n\n";


#  Port the bot should use
print "PORT TO LISTEN ON, FOR BOTH USERS/BOTS\n";
chomp($ports_conf = <STDIN>);
while(length($ports_conf) > 5 || length($ports_conf) < 4 || $ports_conf > 65000) {
	print("Something is wrong...\n please remember, port can't be larger than 65000, try again!\n Also make it atleast 4 numbers long i.e. 5093\n");
chomp($ports_conf = <STDIN>);
}
	print("Continuing...\n\n");

# Servers the bot should connect to
print "SERVER\nFormat: irc.undernet.org or an IP\nSeperate using ,\nExample: irc.undernet.org,zagreb.hr.eu.undernet.org  etc..\n";
chomp($servers_conf = <STDIN>);
@newservers = split ',', $servers_conf;
for $count (0..scalar(@newservers)-1) {
      $newservers[$count] .= "\n";
    }
while(length($servers_conf) < 1) {
	print("Enter a longer server name, please\n");
chomp($servers_conf = <STDIN>);
@newservers = split ',', $servers_conf;
for $count (0..scalar(@newservers)-1) {
      $newservers[$count] .= "\n";
    }
}
	print "Continuing..\n\n";
	
# timezone
print "TIMEZONE i.e. EST PST CST MST?\n";
chomp($timezone_conf = <STDIN>);
while(length($timezone_conf) < 3) {
	print "Please enter your timezone..\n";
chomp($timezone_Conf = <STDIN>);
	}
		print("Continuing...\n\n");
	

# offset
print "OFFSET! i.e. -6 for Central time in CST\n";
chomp($offset_conf = <STDIN>);
while(length($offset_conf) < 2) {
	print "Please enter the offset for your timezone..\n";
chomp($offset_conf = <STDIN>);
}
	print("Continuing...\n\n");
	

# Network to connect to
print "NETWORK TO CONNECT TO, type the number\n
#   0 = EFnet\n
#   1 = IRCnet\n
#   2 = Undernet\n
#   3 = DALnet\n
#   4 = +e/+I/max-modes 20 Hybrid\n
#   5 = Others\n
";
chomp($nettype_conf = <STDIN>);
while(length($nettype_conf) > 1) {
	print("Just enter the number for the network..\n");
chomp($nettype_conf = <STDIN>);
}
		print("Continuing...\n");
		

# Nick length
print "MAXIMUM NICK LENGTH ON $network_conf\n";
chomp($nicklen_conf = <STDIN>);
while(length($nicklen_conf) > 2) {
print "Enter the maximum nick length value of your bot, you can type /version on irc and see the maximum nick length value..\n";
chomp($nicklen_conf = <STDIN>);
} 
	print("Continuing...\n\n");

	
print "Configuration file made.... $fakenick_conf.conf\nPlease make any changes in the config file if you need to such as the servers and stuff. Enjoy..and thanks for using this tool\n\n";


# The eggdrop configuration text starts below..

# Write variables such as botnick to a file a .txt or somethin

open (writeconfig,">$fakenick_conf.conf") || die "cannot append: $!\n";

print writeconfig qq{# Automated eggdrop configuration file built: $curtime
# Author: vigilant
# Version: $ver
# Project date: Oct 23rd 07
# E-mail admin\@anserq.com\ for any problems, suggestions or questions
# www.anserq.com - My website

##################################################################
# All the settings added using the automated configuration program 
##################################################################

# THE BOT'S NICKNAME
set nick2 "$bot_conf"

# THE FAKE NICK
set fakenick "$fakenick_conf"

# THE OWNER'S EMAIL ADDRESS
set owneremail "$email_conf"

# THE OWNER'S IRC NICKNAME
set yournick "$ownernick_conf"

# THE NETWORK'S NAME
set networkname "$network_conf"

# CHANNEL TO JOIN AFTER CONNECTING, DEFAULT CHANNEL
set chan_join "$chantojoin_conf"

# OWNERS NICKNAME(s)  
set owner2 "$owners_conf"

# AWAY MESSAGE FOR BOT, UNCOMMENT IF NEEDED
set awaymsg "$awaymsg_conf"

# Vhost4 or vhost6
$ip_ornot

# Listen on this ip or host and bind to it

set listen-addr "$listen_addr"

# THE BOTS HOSTNAME TO CONNECT TO IRC, USE ONLY IF IP DOES NOT RESOLVE TO HOSTNAME?
#set my-hostname "$host_conf"

# THE BOTS REALNAME FIELD, THAT SHOWS ON IRC: bot@bot.com H.E.R.E in /WHOIS
set realname "$realname_conf"

# THE PORT TO LISTEN ON FOR EVERYONE, BOT'S AND USER'S 
listen $ports_conf all
#listen 3333 bots
#listen 4444 users

# SET THE SERVER'S HERE TO CONNECT TO
set servers {
  @newservers
}

# THE TIMEZONE, LIKE, EST PST CST MST
set timezone "$timezone_conf"

# OFFSET FOR TIMEZONE, SUCH AS -6 FOR CENTRAL TIME ZONE
set offset "$offset_conf"

# NETWORK THE BOT CONNECTS TO
#   0 = EFnet
#   1 = IRCnet
#   2 = Undernet
#   3 = DALnet
#   4 = +e/+I/max-modes 20 Hybrid
#   5 = Others
set net-type $nettype_conf

# THE MAXIMUM LENGHT NICKNAME'S YOUR NETWORK ALLOWS?
set nick-len $nicklen_conf

######################################################
# 					Leave these alone.................
######################################################


### The owner(s) of the bot.
set owner "\$owner2"
###	 Botnet nickname, it's best to leave it the same as the nickname.
set botnet-nick "\$fakenick"
### Your eggdrops user file, all user information is saved here, such as, passwords, flags for channels, info lines.. and more.
set userfile "\$fakenick.user"
### Process ID name.
set pidfile "pid.\$fakenick"
### If you are on a shell, do not touch this
set username "\$nick2"
### Who should the bot notify, important changes...
set notify-newusers "\$owner2"
### set admin nick and email
set admin "\$yournick <email: \$owneremail>"
### set channel file name
set chanfile "\$fakenick.chan"
### set note file name
set notefile "\$fakenick.notes"
# The name of the network the bot connects to.
set network "\$networkname"
####################################  END OF IMPORTANT STUFF.

################ CONTINUE TO EDIT IF NEEDED.

set env(TZ) "$timezone $offset"

# If you want to use a language other than English, please uncomment the below line and change to which one.
# Languages included with Eggdrop: Danish, English, French, Finnish, German.
#addlang "english"

# Log stuff

set max-logs 5
set max-logsize 0
set quick-logs 0
set raw-log 0
## This logfile will log all the commands sent to the bot and whatnot.
logfile mco * "logs/eggdrop.log"
## This setting will log all kicks parts joins netsplit info from channel lamest
#logfile jpk #lamest "logs/lamest.log"
set log-time 1
set timestamp-format {[%H:%M:%S]}
set keep-all-logs 0
set logfile-suffix ".%d%b%Y"
set switch-logfiles-at 300
set quiet-save 0

# Console stuff

set console "mkcobxs"

# Files & directories

set help-path "help/"
set text-path "text/"
set temp-path "/tmp"
set motd "text/motd"
set telnet-banner "text/banner"
set userfile-perm 0600

# botnet/dcc/telnet

set remote-boots 2
set share-unlinks 1
set protect-telnet 0
set dcc-sanitycheck 0
set ident-timeout 0
set require-p 0
set open-telnets 0
set stealth-telnets 1
set use-telnet-banner 1
set connect-timeout 15
set dcc-flood-thr 3
set telnet-flood 3:1
set paranoid-telnet-flood 1
set resolve-timeout 10

# SSL settings
#set ssl-privatekey "eggdrop.key"
#set ssl-certificate "eggdrop.crt"
#set ssl-verify-depth 9
set ssl-capath "/etc/ssl/"
#set ssl-cafile ""
#set ssl-ciphers ""
#set ssl-cert-auth 0
#set ssl-verify-dcc 0
#set ssl-verify-bots 0
#set ssl-verify-clients 0

# advanced settings

#set firewall "!sun-barr.ebay:3666"
#set nat-ip "127.0.0.1"
#set reserved-portrange 2010:2020
set ignore-time 15
set hourly-updates 00
set default-flags "hp"
set whois-fields "url birthday"
#unbind dcc n tcl *dcc:tcl
#unbind dcc n set *dcc:set
set must-be-owner 1
#unbind dcc n simul *dcc:simul
#set max-dcc 50

##### max-socks replaces max-dcc
set max-socks 100
set allow-dk-cmds 1
set dupwait-timeout 5
set strict-host 1
set cidr-support 0

# modules

set mod-path "modules/"

# blowfish module
loadmodule blowfish

# dns module settings

loadmodule dns
#set dns-servers "8.8.8.8 8.8.4.4"
set dns-cache 86400
set dns-negcache 600
set dns-maxsends 4
set dns-retrydelay 3

# channel module settings

loadmodule channels

set force-expire 0
set share-greet 0
set use-info 1

# New one in v2.0 of vigconf
set allow-ps 0

set global-flood-chan 15:60
set global-flood-deop 3:10
set global-flood-kick 3:10
set global-flood-join 5:60
set global-flood-ctcp 3:60
set global-flood-nick 5:60
set global-aop-delay 5:30
set global-idle-kick 0
set global-chanmode "nt"
set global-stopnethack-mode 0
set global-revenge-mode 0
set global-ban-type 3
set global-ban-time 120
set global-exempt-time 60
set global-invite-time 60

set global-chanset {
        -autoop         -autovoice
        -bitch          +cycle
        +dontkickops    +dynamicbans
        +dynamicexempts +dynamicinvites
        -enforcebans    +greet
        -inactive       -nodesynch
        -protectfriends +protectops
        -revenge        -revengebot
        -secret         -seen
        +shared         -statuslog
        +userbans       +userexempts
        +userinvites    -protecthalfops
        -autohalfop     -static
}


# Server settings
loadmodule server
#set ssl-verify-server 0

set nick "\$nick2"
set altnick "\$nick2?"

## runs right after connecting
bind evnt - init-server evnt:init_server
proc evnt:init_server {type} {
  global awaymsg
  global botnick
  putquick "MODE \$botnick +ix-ws"
  $awaystring
}

# channel to join automatically
channel add \$chan_join


set default-port 6667
set msg-rate 2
set keep-nick 1
set strict-host 1
set quiet-reject 1
set lowercase-ctcp 1
set answer-ctcp 3
set flood-msg 5:60
set flood-ctcp 3:60
set server-cycle-wait 60
set server-timeout 60
set check-stoned 1
set serverror-quit 1
set max-queue-msg 300
set trigger-on-ignore 0
set exclusive-binds 0
set double-mode 1
set double-server 1
set double-help 1
set optimize-kicks 2
set stack-limit 4


# net-type 5 #
#set check-mode-r 1

# CTCP STUFF.
loadmodule ctcp
set ctcp-mode 2
set ctcp-version "vigconf v$ver \\[eggdrop]"
set ctcp-finger "vigconf v$ver \\[eggdrop]"
set ctcp-userinfo "vigconf v$ver \\[eggdrop]"


# IRC module
loadmodule irc
set bounce-bans 0
set bounce-exempts 0
set bounce-invites 0
set bounce-modes 0
set max-bans 30
set max-exempts 20
set max-invites 20
set max-modes 30
#set use-exempts 0
#set use-invites 0
set learn-users 0
set wait-split 600
set wait-info 180
set mode-buf-length 200
#unbind msg - hello *msg:hello
#bind msg - myword *msg:hello
#unbind msg - ident *msg:ident
#unbind msg - addhost *msg:addhost
set opchars "@"
#set opchars "@&~"
set no-chanrec-info 0

#net-type 1 #
set prevent-mixing 1

#set kick-method 1
#set modes-per-line 3
#set include-lk 1
#set use-354 0
#set rfc-compliant 1

# transfer module
loadmodule transfer
set max-dloads 3
set dcc-block 0
set copy-to-tmp 1
set xfer-timeout 30


# SHARE MODULE
loadmodule share
#set allow-resync 0
#set resync-time 900
#set private-global 0
#set private-globals "mnot"
#set private-user 0
#set override-bots 0


# Compress module
loadmodule compress
set share-compressed 1
#set compress-level 9


# File system module
#loadmodule filesys
#set files-path "/home/mydir/filesys"
#set incoming-path "/home/mydir/filesys/incoming"
#set upload-to-pwd 0
#set filedb-path ""
#set max-file-users 20
#set max-filesize 1024


# Notes module
loadmodule notes
set max-notes 50
set note-life 60
set allow-fwd 0
set notify-users 0
set notify-onjoin 1

if {[file exists aclocal.m4]} { die {You are attempting to run Eggdrop from the source directory. Please finish installing Eggdrop by running "make install" and run it from the install location.} }

# Console module
loadmodule console
set console-autosave 1
set force-channel 0
set info-party 0

#### WOOBIE MODULE ####
#loadmodule woobie
### SEEN MODULE ####
#loadmodule seen


# assoc module
#loadmodule assoc
# uptime module
#loadmodule uptime

############# SCRIPTS
####################################
source scripts/compat.tcl
source scripts/alltools.tcl
source scripts/action.fix.tcl
source scripts/dccwhois.tcl
source scripts/userinfo.tcl
loadhelp userinfo.help
source scripts/getops.tcl

if {[info exists net-type]} {
  switch -- ${net-type} {
    "0" {
      # EFnet
      source scripts/quotepong.tcl
    }
    "2" {
      # Undernet
      source scripts/quotepass.tcl
    }
  }
}
};
close(writeconfig);